#include "DS1822.h"
#include <LPC21xx.H>
#include "Serial.h"

extern unsigned char DS1822_SERIAL_NUMBER[MAX_SENSORS][DS1822_SERIAL_NUM_SIZE];

char err_cnt[8];

int main(void)
{
	char cnt,cnt2;
	PINSEL0 = 0x00050000;           /* Enable RxD1 and TxD1                     */
	U1LCR = 0x83;                   /* 8 bits, no Parity, 1 Stop bit            */
	U1DLL = 82;                     /* 9600 Baud Rate @ 10MHz VPB Clock         */
	U1LCR = 0x03;                   /* DLAB = 0 								*/

	uart_print_string("LPC2101 1-Wire Test Starts...",1);

	for (cnt=0;cnt!=8;cnt++) 
	{
		err_cnt[cnt] = DS1822_Search_Rom((1<<4),cnt);

		if(DS1822_SERIAL_NUMBER[cnt][0]!=0)
		{
			uart_print_string("Found 1-Wire Device N:",0);

			for(cnt2=0;cnt2!=7;cnt2++)
			{
				uart_print_string(" ",0);
				lcd_print_hex_value(DS1822_SERIAL_NUMBER[cnt][cnt2]);
			}
			uart_print_string(" CRC:",0);
			lcd_print_hex_value(DS1822_SERIAL_NUMBER[cnt][7]);
			uart_print_string(" ",1);
		}
		else
		uart_print_string("No Device found",1);
	}
	uart_print_string("Found BUS ERRORs...",1);
	for (cnt2=0;cnt2!=8;cnt2++)
	{
		uart_print_string("Device ",0);
		lcd_print_value(cnt2);
		if (err_cnt[cnt2]!=0) {uart_print_string(" errors found: ",0); lcd_print_value(err_cnt[cnt2]);}
		else uart_print_string(" Ok! No errors. ",0);
		uart_print_string(" ",1);
	}

}
